#include <iostream>
#include <vector>

using namespace std;

/* C++ parameterized types, called templates
 * Equivalent to Java Generics
 * please refer to
 * http://www.cplusplus.com/reference/stl
 * for the full documentation.
 */
int main()
{
   vector<int> numbers;
   for(int i = 0; i < 10; i++)
      numbers.push_back(i);
   
   // now numbers contains 0 - 9
   
   // C++ style iterator:
   vector<int>::iterator it;

   cout << "numbers contains:" << endl;
   for(it = numbers.begin(); it < numbers.end(); it++)
      cout << *it << " ";
   cout << endl;

   // reverse:
   vector<int>::reverse_iterator rit;
   cout << "numbers contains in reverse:" << endl;
   for(rit = numbers.rbegin(); rit < numbers.rend(); rit++)
      cout << *rit << " ";
   cout << endl;

   return 0;

}
